// Converted to C and H files by Softools, Inc. DC2ANSI utility - Version 1.7

#include "dcdefs.h"
#include "TIMERB.h"
#include "rabbit.h"

//#define XTAL_FREQ ((long)_serial19200TC * 307200l)

#if DEBUG_RST
#define MIN_TIMER 200
#else
#define MIN_TIMER 165
#endif

static int _timerb_inc;
// used by isr
static unsigned int _timerb_ctr;
unsigned int _timerb_scale; // made public for demo
static float _timerb_divisor;
static int _timerb_match=0;

/* START FUNCTION DESCRIPTION ********************************************
_TimerBISR                       <TIMERB.LIB>

SYNTAX:		interrupt _TimerBISR()

DESCRIPTION:
				Internal ISR handler in TIMERB.LIB, Calls TimerBRoutine()
RETURN VALUE:	None.
END DESCRIPTION **********************************************************/

#ifndef FAST_TIMERB
static void _int _nostep _TimerBISR(void)
{
#asm
#else
static void near _nostep _TimerBISR(void)
{
#asm
	push	af
	push	de
	push	hl
#endif
	ld		hl,(__timerb_match)
	ld		a,h
	or		0x3f	// will cause carry to bit 8 to propigate to bit 14
	ld		h,a
	ld		de,(__timerb_inc)
	add	hl,de
	ld		(__timerb_match),hl
	ipset	3
	ioi	ld a, (TBCSR)			; load B1, B2 interrupt flags (clears flag)
	ld		a,h
	ioi	ld (TBM1R), a			; NOTE:  you _need_ to reload the match
	ld		a,l						; next low in a
	ioi	ld (TBL1R), a			; set up next B1 match (at timer=0000h)
								;	register after every interrupt!
	ipres
; are we scaling int calls to user routine?
	ld		hl,(__timerb_scale)
	bool	hl
	jr		z,no_scale
; ok so we need to count down
	ld		hl,(__timerb_ctr)
	dec	hl
	ld		(__timerb_ctr),hl
	bool	hl
	jr		nz,skip_user
	ld		hl,(__timerb_scale)
	ld		(__timerb_ctr),hl
no_scale:
	call	_TimerBRoutine##			; do user func
skip_user:
#ifdef FAST_TIMERB
	pop	hl
	pop	de
	pop	af
#endif
#endasm
}


//
// divisor = usec * _serial19200TC * 307200 / 1000000;
// to keep within 32 bit we divide the 2 constants by 100
// divisor = usec * _serial19200TC * 3072 / 10000;
//  fort large usec the multiply will till overflow, so we
// scale by /10 until we can multiply by 3072
int _nostep TimerBInit(unsigned long usec,char intlevel)
{
	static char timera_mod=0;
	unsigned long divisor;
	int	timeradiv;
	unsigned scale10=4;
	static unsigned scale[5]={1,10,100,1000,10000};
	unsigned long intscale;
	_timerb_match=0;
	ini(TBCSR);		// clear any pending int
	ioSrOutI(TBCSR, 0x00);	// disable timer B and its interrupts
	ioSrOutI(TBCR, 0x04);	// disable timer B and its interrupts (use timer A clock)
	ini(TBCSR);		// clear any pending int
	_timerb_scale=0;	// no scale be default
	// if serial ports are usung timer A1 we cant modify it.
	timeradiv=(int)srTAT1R+1;
	if (timeradiv==1)
		timera_mod=1;	// we can change it
	if (timera_mod)
		timeradiv=256;	// use max as default

	while (usec&0xff000000l)
	{
		usec=(usec+5)/10l;
		scale10--;
	}
	divisor=usec * (unsigned long)_serial19200TC;
	while (divisor>1398101l)
	{
		divisor=(divisor+5)/10l;
		if (scale10==0)
			return 1;
		scale10--;
	}
	divisor*=3072l;
	scale10=scale[scale10];
	divisor=(divisor+(scale10>>2))/(unsigned long)scale10;
	intscale=divisor/1024l;
	if (intscale<timeradiv)	// max for using both timer a and b
	{
		if (intscale==0l)	// timer b only
		{
			intlevel&=3;		// mask valid
			_timerb_divisor=divisor;
			if (divisor<MIN_TIMER)	// not enough instructions for accurate time between ints
				return 1;
		}
		else
		if (intscale<8l)	// timer b clk/16
		{
			intlevel=0x8|(intlevel&3);		// mask valid set pclk/2
			divisor=(divisor+4l)/8;
			_timerb_divisor=divisor*8l;
		}
		else
		{
			// use timera
			if (timera_mod) // this is unused so we can modify it
			{
				timeradiv=(int)((divisor+1023l)/1024l);
				ioSrOutI(TAT1R,timeradiv-1);	// use new val
			}
			intlevel=0x4|(intlevel&3);		// mask valid set timera
			// try to calc best value
		 	divisor=(divisor+(timeradiv>>1))/timeradiv; // nearest multiple of timeradiv
			_timerb_divisor=divisor*timeradiv;
		}
	}
	else // timera+timerB+timerscale
	{
		intlevel=0x4|(intlevel&3);		// mask valid set timera
		ioSrOutI(TAT1R,timeradiv-1);	// use new val
	 	divisor=(divisor+(timeradiv>>1))/timeradiv; // nearest multiple of timeradiv
		intscale=(divisor+1023)/1024l;
		divisor=(divisor+(intscale>>1))/intscale;
		if (divisor>1024l)	// max for using both timer a and b and scale
			return 1;
		_timerb_scale=(unsigned int) intscale;	// init first
#ifdef TIMERB_IMMEDIATE
		_timerb_ctr=1;	// call isr on first int
#else
		_timerb_ctr=_timerb_scale;
		if (divisor!=1024)
			_timerb_ctr++;
#endif
		_timerb_divisor=divisor*intscale*(unsigned long)timeradiv;
	}

	_timerb_inc=(int)((divisor&0xff)|((divisor<<6)&0xc000));	// val for isr
//	ipset3();
#asm
	ioi ld	a,(TBCLR)
	ld		l,a
	ioi ld	a,(TBCMR)
	or		0x3f
	ld		h,a
	ld		de,(__timerb_inc)
	add	hl,de
	ld		(__timerb_match),hl
	ld 	a,h
	ioi ld (TBM1R),a
	ld		a,l
	ioi ld (TBL1R),a
	ld	a,0x3
	ioi ld (TBCSR),a
	ld (_srTBCSR),a
#endasm
	setInterruptHandler(INT_TIMER_B, _TimerBISR);	   // set up ISR
	ioSrOutI(TBCR,intlevel);	// clock timer B with clock source and int level
//	ipres();
#ifdef TIMER_DEBUG
	printf("Timer B divisor=%ld, _timerb_scale=%u, timeradiv=%d, match=%x\n",
	divisor,_timerb_scale,timeradiv,_timerb_match);
#endif
	return 0; // :-)
}

float TimerBRate()
{
	return (_timerb_divisor*1000000.0)/((float) _serial19200TC * 307200.0);
}


/* START FUNCTION DESCRIPTION ********************************************
TimerBUninit                       <TIMERB.LIB>

SYNTAX:		void TimerBUninit()

DESCRIPTION:
RETURN VALUE:	None.
END DESCRIPTION **********************************************************/

void TimerBUninit(void)
{
	outi(TBCSR, srTBCSR=0x00);	// disable timer B and its interrupts
}

